您的位置:首页 > 其它

CF - 777C. Alyona and Spreadsheet 单调栈、dp

2017-02-24 22:32 555 查看
1.题目描述:

C. Alyona and Spreadsheet

time limit per test
1 second

memory limit per test
256 megabytes

input
standard input

output
standard output

During the lesson small girl Alyona works with one famous spreadsheet computer program and learns how to edit tables.

Now she has a table filled with integers. The table consists of n rows and m columns.
By ai, j we
will denote the integer located at the i-th row and the j-th
column. We say that the table is sorted in non-decreasing order in the column j if ai, j ≤ ai + 1, j for
all i from 1 to n - 1.

Teacher gave Alyona k tasks. For each of the tasks two integers l and r are
given and Alyona has to answer the following question: if one keeps the rows from l to r inclusive
and deletes all others, will the table be sorted in non-decreasing order in at least one column? Formally, does there exist such j that ai, j ≤ ai + 1, j for
all i from l to r - 1 inclusive.

Alyona is too small to deal with this task and asks you to help!

Input

The first line of the input contains two positive integers n and m (1 ≤ n·m ≤ 100 000) —
the number of rows and the number of columns in the table respectively. Note that your are given a constraint that bound the product of these two integers, i.e. the number of elements in the table.

Each of the following n lines contains m integers.
The j-th integers in the i of
these lines stands for ai, j (1 ≤ ai, j ≤ 109).

The next line of the input contains an integer k (1 ≤ k ≤ 100 000) —
the number of task that teacher gave to Alyona.

The i-th of the next k lines
contains two integers li and ri (1 ≤ li ≤ ri ≤ n).

Output

Print "Yes" to the i-th line of
the output if the table consisting of rows from li to ri inclusive
is sorted in non-decreasing order in at least one column. Otherwise, print "No".

Example

input
5 4
1 2 3 5
3 1 3 2
4 5 2 3
5 5 3 2
4 4 3 4
6
1 1
2 5
4 5
3 5
1 3
1 5


output
Yes
No
Yes
Yes
Yes
No


Note

In the sample, the whole table is not sorted in any column. However, rows 1–3 are sorted in column 1, while rows 4–5 are sorted in column 3.

2.题意概述:

给出n*m矩阵,每次查询l ~ r 的行区间,问你其中的m列是否存在某一列呈不递减趋势

3.解题思路:

最开始看成行,结果卡了很久,快结束了才发现,以后看题要仔细!!然后就是注意坑点是1 <= n * m <= 100000 ,如果暴力可能会MLE,而且不预处理肯定会T的

做法就是vector存矩阵,对每一列dp用单调栈维护第i行最左边的下标,那么每次查询l ~ r直接判断ans[r] 是不是 <=  l就行了,貌似这题用线段树更快?看来需要提升姿势啊

4.AC代码:

#include <bits/stdc++.h>
#define INF 0x3f3f3f3f
#define maxn 100100
#define N 1111
#define eps 1e-6
#define pi acos(-1.0)
#define e 2.718281828459
#define mod (int)1e9 + 7
using namespace std;
typedef long long ll;
vector<int> a[maxn];
int ans[maxn], tmp[maxn];
int main()
{
#ifndef ONLINE_JUDGE
freopen("in.txt", "r", stdin);
freopen("out.txt", "w", stdout);
long _begin_time = clock();
#endif
int n, m, k;
scanf("%d%d", &n, &m);
memset(ans, 0x3f, sizeof(ans));
for (int i = 1; i <= n; i++)
{
a[i].push_back(0);
for (int j = 1; j <= m; j++)
{
int x;
scanf("%d", &x);
a[i].push_back(x);
}
}
for (int j = 1; j <= m; j++)
{
int first = 1;
tmp[1] = 1;
for (int i = 2; i <= n; i++)
{
if (a[i][j] < a[i - 1][j])
first = i;
tmp[i] = first;
}
for (int i = 1; i <= n; i++)
ans[i] = min(ans[i], tmp[i]);
}
scanf("%d", &k);
while (k--)
{
int l, r;
scanf("%d%d", &l, &r);
if (ans[r] <= l)
puts("Yes");
else
puts("No");
}
#ifndef ONLINE_JUDGE
long _end_time = clock();
printf("time = %ld ms.", _end_time - _begin_time);
#endif
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  算法 acm codeforces